config/routes.rb
Rails.application.routes.draw do
  root 'movies#index'
  
  devise_for :users, controllers: { registrations: "users/registrations" }
  
  resources :movies

  resources :celeb_users, only: [:show, :new, :create, :edit, :update, :destroy] do
    collection do
      get :actors
      get :producers
      get :directors
    end
  end

  # version 1
  api_version(:module => "V1", :path => {:value => "v1"}, :defaults => {:format => :json}) do

    mount_devise_token_auth_for 'User', at: 'users', controllers: { registrations: 'v1/users/registrations' }

    resources :movies

    resources :celeb_users, only: [:show, :new, :create, :edit, :update, :destroy] do
      collection do
        get :actors
        get :producers
        get :directors
      end
    end
  end
end

app/models/celeb_user.rb
class CelebUser < ApplicationRecord
  has_many :actor_movies
  has_many :movies_as_actor, through: :actor_movies, source: :movie

  has_many :director_movies
  has_many :movies_as_director, through: :director_movies, source: :movie

  has_many :producer_movies
  has_many :movies_as_producer, through: :producer_movies, source: :movie

  enum role: [:actor, :producer, :director]

  scope :actors, -> { where(role: :actor) }
  scope :producers, -> { where(role: :producer) }
  scope :directors, -> { where(role: :director) }

  def full_name
    first_name + " " + last_name
  end

end

app/controllers/celeb_users_controller.rb
class CelebUsersController < ApplicationController
  before_action :authenticate_user!, except: [:show, :actors, :directors, :producers]
  before_action :authenticate_user_as_admin, only: [:new, :create, :update, :destroy]
  before_action :set_celeb_user, only: [:show, :edit, :update, :destroy]
  serialization_scope :view_context

  def new
    @celeb_user = CelebUser.new
  end
  
  def actors
    @celeb_users = CelebUser.actors
  end

  def directors
    @celeb_users = CelebUser.directors
  end

  def producers
    @celeb_users = CelebUser.producers
  end

  def show
  end

  def create
    @celeb_user = CelebUser.new(celeb_user_params)

    if @celeb_user.save
      redirect_to @celeb_user, notice: 'Celeb User was successfully created.'
    else
      render :new
    end
  end

  def update
    # Cause celebuser role cannot be changed
    params[:celeb_user][:role] = @celeb_user.role
    
    if @celeb_user.update(celeb_user_params)
      redirect_to @celeb_user, notice: 'User was successfully updated.'
    else
      render :edit
    end
  end

  def destroy
    @celeb_user.destroy
      redirect_to users_url, notice: 'User was successfully destroyed.'
  end


  private
    def set_celeb_user
      @celeb_user = CelebUser.find(params[:id])
    end

    def celeb_user_params
      params.require(:celeb_user).permit(:first_name, :last_name, :role)
    end

end

app/controllers/v1/celeb_users_controller.rb
class V1::CelebUsersController < V1::BaseController
  before_action :authenticate_user!, except: [:show, :actors, :directors, :producers]
  before_action :authenticate_user_as_admin, only: [:create, :update, :destroy]
  before_action :set_celeb_user, only: [:show, :update, :destroy]
  serialization_scope :view_context

  def actors
    @celeb_users = CelebUser.actors
    render json: @celeb_users
  end

  def directors
    @celeb_users = CelebUser.directors
    render json: @celeb_users
  end

  def producers
    @celeb_users = CelebUser.producers
    render json: @celeb_users
  end

  def show
    render json: @celeb_user
  end

  def create
    @celeb_user = CelebUser.new(celeb_user_params)

    if @celeb_user.save
      render json: @celeb_user
    else
      render json: @celeb_user.errors, status: :unprocessable_entity
    end
  end

  def update
    # Cause celebuser role cannot be changed
    params[:celeb_user][:role] = @celeb_user.role
    
    if @celeb_user.update(celeb_user_params)
      render json: @celeb_user
    else
      render json: @celeb_user.errors, status: :unprocessable_entity
    end
  end

  def destroy
    @celeb_user.destroy
    render json: {success: true, message: "Celeb User has been removed successfully."}
  end


  private
    def set_celeb_user
      @celeb_user = CelebUser.find(params[:id])
    end

    def celeb_user_params
      params.require(:celeb_user).permit(:first_name, :last_name, :role)
    end

end

app/views/celeb_users/_form.html.haml
= form_for @celeb_user do |f|
  - if @celeb_user.errors.any?
    #error_explanation
      %h2= "#{pluralize(@celeb_user.errors.count, "error")} prohibited this celeb user from being saved:"
      %ul
        - @celeb_user.errors.full_messages.each do |message|
          %li= message
  .form-group
    = f.label :first_name, class: "col-sm-1 control-label text-left-imp"
    .col-sm-11
      = f.text_field :first_name, class: "form-control"
  .form-group
    = f.label "last_name", class: "col-sm-1 control-label text-left-imp"
    .col-sm-11
      = f.text_field :last_name, class: "form-control"
  - if params["action"] == "new"
    .form-group
      = f.label :role, class: "col-sm-1 control-label text-left-imp"
      .col-sm-11
        = f.select :role, options_for_select(["actor", "producer", "director"], f.object.role), {}, class: "form-control"
  %hr
  .actions
    = f.submit 'Save'

app/views/celeb_users/actors.html.haml
%h1 Actors List

- if @celeb_users.present?
  %table
    %thead
      %tr
        %th Name
        %th
        %th
        %th

    %tbody
      - @celeb_users.each do |celeb_user|
        %tr
          %td= celeb_user.full_name.titleize
          %td= link_to 'Show', celeb_user
          - if current_user && current_user.admin?
            %td= link_to 'Edit', edit_celeb_user_path(celeb_user)
            %td= link_to 'Destroy', celeb_user, method: :delete, data: { confirm: 'Are you sure?' }
- else
  %h3 There are no actors yet.
%br
- if current_user && current_user.admin?
  = link_to 'New Actor', new_celeb_user_path

app/views/celeb_users/directors.html.haml
%h1 Directors List

- if @celeb_users.present?
  %table
    %thead
      %tr
        %th Name
        %th
        %th
        %th

    %tbody
      - @celeb_users.each do |celeb_user|
        %tr
          %td= celeb_user.full_name.titleize
          %td= link_to 'Show', celeb_user
          - if current_user && current_user.admin?
            %td= link_to 'Edit', edit_celeb_user_path(celeb_user)
            %td= link_to 'Destroy', celeb_user, method: :delete, data: { confirm: 'Are you sure?' }
- else
  %h3 There are no directors yet.
%br
- if current_user && current_user.admin?
  = link_to 'New Director', new_celeb_user_path

app/views/celeb_users/edit.html.haml
%h1 Editing celeb user

= render 'form'

= link_to 'Show', @celeb_user
\|
= link_to 'Back', celeb_users_path

app/views/celeb_users/new.html.haml
%h1 New celeb user

= render 'form'

= link_to 'Back', celeb_users_path

app/views/celeb_users/producers.html.haml
%h1 Producers List

- if @celeb_users.present?
  %table
    %thead
      %tr
        %th Name
        %th
        %th
        %th

    %tbody
      - @celeb_users.each do |celeb_user|
        %tr
          %td= celeb_user.full_name.titleize
          %td= link_to 'Show', celeb_user
          - if current_user && current_user.admin?
            %td= link_to 'Edit', edit_celeb_user_path(celeb_user)
            %td= link_to 'Destroy', celeb_user, method: :delete, data: { confirm: 'Are you sure?' }
- else
  %h3 There are no producers yet.
%br
- if current_user && current_user.admin?
  = link_to 'New Producer', new_celeb_user_path

app/views/celeb_users/show.html.haml
.row
  .col-lg-12.col-xs-6
    .box
      .box-header.with-border
        %h3.box-title
          %b= @celeb_user.full_name.titleize
      .box-body
        - if @celeb_user.actor?
          %h5 Movies as casting:
          %ul
            - @celeb_user.movies_as_actor.each do |movie|
              %li= link_to movie.title.titleize, movie_path(movie)
          %hr
        - elsif @celeb_user.director?
          %h5 Movies as director:
          %ul
            - @celeb_user.movies_as_director.each do |movie|
              %li= link_to movie.title.titleize, movie_path(movie)
          %hr
        - elsif @celeb_user.producer?
          %h5 Movies as producer:
          %ul
            - @celeb_user.movies_as_producer.each do |movie|
              %li= link_to movie.title.titleize, movie_path(movie)